package be.hub.bookwise.dao;

import java.util.List;

import javax.persistence.EntityManager;
import javax.persistence.EntityManagerFactory;
import javax.persistence.PersistenceUnit;
import javax.persistence.Query;

import be.hub.bookwise.domain.Account;

public class AccountJpaDAO implements AccountDAO {
	
	private EntityManagerFactory emf;

    @PersistenceUnit
    public void setEntityManagerFactory(EntityManagerFactory emf) {
        this.emf = emf;
    }

	@SuppressWarnings("unchecked")
	public List<Account> getAll() {
		EntityManager entityManager = this.emf.createEntityManager();
		Query query = entityManager.createQuery("select account from Account account"); 
		return query.getResultList();
	}

	public Account getById(Long id) {
		EntityManager entityManager = this.emf.createEntityManager();
		Query query = entityManager.createQuery("select account from Account account where account.id = :id");
		query.setParameter("id", id);
		return (Account) query.getSingleResult();
	}

	public void save(Account obj) {
		EntityManager entityManager = this.emf.createEntityManager();
		entityManager.getTransaction().begin();
		entityManager.persist(obj);
		entityManager.getTransaction().commit();

	}
	
	public List<Account> getOwned(){
		return null;
	}

	public void update(Account obj) {
		EntityManager entityManager = this.emf.createEntityManager();
		entityManager.getTransaction().begin();
		entityManager.merge(obj);
		entityManager.getTransaction().commit();
	}

}
