package be.hub.bookwise.dao;

import java.util.List;

import javax.persistence.EntityManager;
import javax.persistence.EntityManagerFactory;
import javax.persistence.PersistenceUnit;
import javax.persistence.Query;

import be.hub.bookwise.domain.Order;
import be.hub.bookwise.domain.Product;

public class OrderJpaDAO implements OrderDAO {
	
	private EntityManagerFactory emf;

    @PersistenceUnit
    public void setEntityManagerFactory(EntityManagerFactory emf) {
        this.emf = emf;
    }

	@SuppressWarnings("unchecked")
	public List<Order> getAll() {
		EntityManager entityManager = this.emf.createEntityManager();
		Query query = entityManager.createQuery("select o from Order o"); 
		return query.getResultList();
	}

	public Order getById(Long id) {
		EntityManager entityManager = this.emf.createEntityManager();
		Query query = entityManager.createQuery("select o from Order o where o.id = :id");
		query.setParameter("id", id);
		return (Order) query.getSingleResult();
	}

	public void save(Order obj) {
		EntityManager entityManager = this.emf.createEntityManager();
		entityManager.getTransaction().begin();
		entityManager.persist(obj);
		entityManager.getTransaction().commit();

	}

	public List<Order> getByProduct(Product product) {
		// TODO Auto-generated method stub
		return null;
	}

	public void update(Order obj) {
		EntityManager entityManager = this.emf.createEntityManager();
		entityManager.getTransaction().begin();
		entityManager.merge(obj);
		entityManager.getTransaction().commit();
	}
	
}
