package be.hub.bookwise.dao;

import java.util.List;

import javax.persistence.EntityManager;
import javax.persistence.EntityManagerFactory;
import javax.persistence.PersistenceUnit;
import javax.persistence.Query;

import be.hub.bookwise.domain.Product;

public class ProductJpaDAO implements ProductDAO {
	
	private EntityManagerFactory emf;

    @PersistenceUnit
    public void setEntityManagerFactory(EntityManagerFactory emf) {
        this.emf = emf;
    }

	@SuppressWarnings("unchecked")
	public List<Product> getAll() {
		EntityManager entityManager = this.emf.createEntityManager();
		Query query = entityManager.createQuery("select product from Product product"); 
		return query.getResultList();
	}

	public Product getById(String id) {
		EntityManager entityManager = this.emf.createEntityManager();
		Query query = entityManager.createQuery("select product from Product product where product.id = :id");
		query.setParameter("id", id);
		return (Product) query.getSingleResult();
	}

	public void save(Product obj) {
		EntityManager entityManager = this.emf.createEntityManager();
		entityManager.getTransaction().begin();
		entityManager.persist(obj);
		entityManager.getTransaction().commit();

	}

	
	public void update(Product obj) {
		EntityManager entityManager = this.emf.createEntityManager();
		entityManager.getTransaction().begin();
		entityManager.merge(obj);
		entityManager.getTransaction().commit();
	}
}
