package be.hub.bookwise.domain;

import java.io.Serializable;

import javax.persistence.*;

import org.hibernate.validator.constraints.Email;

@SuppressWarnings("serial")
@Entity
@Table(name = "accounts")
public class Account implements Serializable {

	@Id
	@GeneratedValue(strategy = GenerationType.AUTO)
	Long id;

	@Column(name = "name", unique = true)
	String name;

	@Column(name = "address")
	String address;

	@Column(name = "trade_num", unique = true)
	String tradeNumber;

	@Column(name = "website", nullable = true)
	String website;

	@Column(name = "tel_num", nullable = true)
	String telephoneNumber;

	@Column(name = "fax_num", nullable = true)
	String faxNumber;

	@Column(name = "owned")
	boolean owned;

	@Column(name = "email")
	@Email
	String email;
	

	public String getName() {
		return name;
	}

	public void setName(String name) {
		this.name = name;
	}

	public String getAddress() {
		return address;
	}

	public void setAddress(String address) {
		this.address = address;
	}

	public String getTradeNumber() {
		return tradeNumber;
	}

	public void setTradeNumber(String tradeNumber) {
		this.tradeNumber = tradeNumber;
	}

	public String getWebsite() {
		return website;
	}

	public void setWebsite(String website) {
		this.website = website;
	}

	public String getTelephoneNumber() {
		return telephoneNumber;
	}

	public void setTelephoneNumber(String telephoneNumber) {
		this.telephoneNumber = telephoneNumber;
	}

	public String getFaxNumber() {
		return faxNumber;
	}

	public void setFaxNumber(String faxNumber) {
		this.faxNumber = faxNumber;
	}

	public boolean isOwned() {
		return owned;
	}

	public void setOwned(boolean owned) {
		this.owned = owned;
	}

	public String getEmail() {
		return email;
	}

	public void setEmail(String email) {
		this.email = email;
	}

	public Long getId() {
		return id;
	}

	public void setId(Long id) {
		this.id = id;
	}

}
