package be.hub.bookwise.domain;

import java.io.Serializable;
import java.util.Date;

import javax.persistence.*;
import javax.validation.constraints.NotNull;

import org.springframework.format.annotation.DateTimeFormat;

@SuppressWarnings("serial")
@Entity
@Table(name="orders")
public class Order implements Serializable{

	@Id 
	@GeneratedValue(strategy=GenerationType.AUTO)
	Long id;

	@ManyToOne
    @JoinColumn(name="unit", nullable=false)
	Product unit;
	
	@Column(name="qty")
	Long quantity;
	
	@Column(name="price")
	Long price;
	
	@Column(name="date")
	@DateTimeFormat(pattern="yyyy-MM-dd")
	Date date;
	
	@Column(name="exp_date")
	@DateTimeFormat(pattern="yyyy-MM-dd")
	Date expDate; // expiration date
	
	@ManyToOne
    @JoinColumn(name="benefactor", nullable=false)
	Account benefactor; // schuldenaar (van)
	
	@ManyToOne
    @JoinColumn(name="beneficiary", nullable=false)
	Account beneficiary; // verschuldigde (naar)

	@Column
	boolean closed;	
	
	
	/*
	 * Form fields
	 * Velden nodig om het form te doen werken
	 */
	@NotNull
	String formProduct;
	@NotNull
	String formBenefactor;

	public Long getId() {
		return id;
	}

	public void setId(Long id) {
		this.id = id;
	}

	public Product getUnit() {
		return unit;
	}

	public void setUnit(Product unit) {
		this.unit = unit;
	}

	public Long getQuantity() {
		return quantity;
	}

	public void setQuantity(Long quantity) {
		this.quantity = quantity;
	}

	public Long getPrice() {
		return price;
	}

	public void setPrice(Long price) {
		this.price = price;
	}

	public Date getDate() {
		return date;
	}

	public void setDate(Date date) {
		this.date = date;
	}

	public Date getExpDate() {
		return expDate;
	}

	public void setExpDate(Date expDate) {
		this.expDate = expDate;
	}

	public Account getBenefactor() {
		return benefactor;
	}

	public void setBenefactor(Account benefactor) {
		this.benefactor = benefactor;
	}

	public Account getBeneficiary() {
		return beneficiary;
	}

	public void setBeneficiary(Account beneficiary) {
		this.beneficiary = beneficiary;
	}

	public boolean isClosed() {
		return closed;
	}

	public void setClosed(boolean closed) {
		this.closed = closed;
	}

	public String getFormProduct() {
		return formProduct;
	}

	public void setFormProduct(String formProduct) {
		this.formProduct = formProduct;
	}

	public String getFormBenefactor() {
		return formBenefactor;
	}

	public void setFormBenefactor(String formBenefactor) {
		this.formBenefactor = formBenefactor;
	}

}
