package be.hub.bookwise.domain;

import java.io.Serializable;

import javax.persistence.*;

@SuppressWarnings("serial")
@Entity
@Table(name = "products")
public class Product implements Serializable {

	@Id
	@Column(unique = true, name = "prod_code")
	String code;

	@Column(name = "name")
	String name;

	@Column(name = "description", nullable = true)
	String description;

	// alleen merge om geen fout te krijgen (detached object to persist)
	@OneToOne(cascade = CascadeType.MERGE) 
	Account supplier;

	String supplierFormId;
	
	public String getCode() {
		return code;
	}

	public void setCode(String code) {
		this.code = code;
	}

	public String getName() {
		return name;
	}

	public void setName(String name) {
		this.name = name;
	}

	public Account getSupplier() {
		return supplier;
	}

	public void setSupplier(Account supplier) {
		this.supplier = supplier;
	}

	public String getDescription() {
		return description;
	}

	public void setDescription(String description) {
		this.description = description;
	}
	
	public String getSupplierFormId() {
		return supplierFormId;
	}

	public void setSupplierFormId(String supplierFormId) {
		this.supplierFormId = supplierFormId;
	}

}
